// Faan Tone Liu 01/15/02
// Find repetitions at least 3 characters long in a character array
// Output: distance apart these repetitions occur in string
// Alternate code using string object

#include <iostream>
#include <string.h>

using namespace std;

int main()
{
    string search("mrbjgapwtwegmpyuqrfvmbrfwkoouilboohiimpyrhhvvn"
                  "bcvyngsswtdbeaefoowhdffeclubvclubvsdffuulhfjiqs"
                  "esnwmpyajffimbrfer");
    int searchlen(3);
    int loc;

    // Starting at each point in the string, take a short substring,
    // and look for a match further down the line
    for (int i(0); i < search.length() - 2*searchlen; i++) {
        loc = 0;
        do {
            loc = search.find(search.substr(i,searchlen),i+loc + searchlen);
            if (loc < string::npos) {
                cout << "spacing between repeats: " << loc-i << endl;
            }
        } while (loc < string::npos);
    }
    return 0;
}
